﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Xps;
using System.Printing;
using Infragistics.Controls.Maps;
using xamNetworkNode_Intro.Data;

namespace xamNetworkNode_flowdocument
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public static PrintDialog GetPrintDialog()
        {
            PrintDialog printDialog = null;
            PrintDialog dlg = new PrintDialog();

            if (dlg.ShowDialog() == true)
                printDialog = dlg;

            return printDialog;
        }

        private static void PrintDocumentPaginator(XpsDocumentWriter xpsDocumentWriter, DocumentPaginator document)
        {
            xpsDocumentWriter.Write(document);
        }

        private static XpsDocumentWriter GetPrintXpsDDocumentWriter(PrintQueue printQueue)
        {
            XpsDocumentWriter xpsWriter = PrintQueue.CreateXpsDocumentWriter(printQueue);
            return xpsWriter;
        }

        public static void PrintFlowDocument(PrintQueue printQueue, DocumentPaginator document)
        {
            XpsDocumentWriter xpsDocumentWriter = GetPrintXpsDDocumentWriter(printQueue);
            PrintDocumentPaginator(xpsDocumentWriter, document);
        }

        private void btnPrintNetworkNode(object sender, RoutedEventArgs e)
        {
            LayoutRoot.Children.Remove(xnn);
            xnn.Visibility = System.Windows.Visibility.Visible;

            FlowDocument fdoc = new FlowDocument();
            BlockUIContainer bContainer = new BlockUIContainer();
            bContainer.Child = xnn;
            fdoc.Blocks.Add(bContainer);

            IDocumentPaginatorSource flowDoc = fdoc;

            PrintDialog flowPrintDialog = GetPrintDialog();
            if (flowPrintDialog == null)
                return;

            PrintQueue flowPrintQueue = flowPrintDialog.PrintQueue;
            PrintFlowDocument(flowPrintQueue, flowDoc.DocumentPaginator);

            // Remove the XamNetworkNode from the BlockUIContainer.
            bContainer.Child = null;
            
            // The control still has a Visual as a parent. Need to fix this before we can add it back to the Grid.
            ContainerVisual visual = VisualTreeHelper.GetParent(xnn) as ContainerVisual;
            visual.Children.Remove(xnn);

            // Hide the control again and add it to the grid.
            xnn.Visibility = System.Windows.Visibility.Hidden;
            LayoutRoot.Children.Add(xnn);
        }
    }
}
